/*! \file picloudclient.h
 * \brief PICloud Client
*/
/*
	PIP - Platform Independent Primitives
	PICloud Client
	Ivan Pelipenko peri4ko@yandex.ru, Andrey Bychkov work.a.b@yandex.ru

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef PICLOUDCLIENT_H
#define PICLOUDCLIENT_H

#include "picloudbase.h"
#include "piconditionvar.h"


class PIP_CLOUD_EXPORT PICloudClient : public PIIODevice, private PICloudBase
{
	PIIODEVICE(PICloudClient)
public:
	//!
	explicit PICloudClient(const PIString & path = PIString(), PIIODevice::DeviceMode mode = PIIODevice::ReadWrite);
	virtual ~PICloudClient();

	void setServerName(const PIString & server_name);
	void setKeepConnection(bool on);
	bool isConnected() const {return is_connected;}

protected:
	bool openDevice();
	bool closeDevice();
	int readDevice(void * read_to, int max_size);
	int writeDevice(const void * data, int size);
	DeviceInfoFlags deviceInfoFlags() const {return PIIODevice::Reliable;}


private:
	EVENT_HANDLER1(void, _readed, PIByteArray &, data);
	PIByteArray buff;
	PIMutex mutex_buff;
	PIMutex mutex_connect;
	PIConditionVariable cond_buff;
	PIConditionVariable cond_connect;
	std::atomic_bool is_connected;
};

#endif // PICLOUDCLIENT_H
